// Klasse Brett
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.Border;

public class Brett extends JFrame implements ActionListener {
    static String version = "1.5";
    int zeilen  = 8;
    int spalten = 12;
    int size    = 45;
    JButton current;    // Last square
    JLabel[] scoreLabel;
    Spieler[] spieler = new Spieler[2];
    Feld[][] felder;
    boolean gameOver = false;
    
    public Brett() {
        setTitle( "Springer-Reise");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	spieler[0] = new Spieler( 0, 0 );
	//	spieler[1] = new Computer( spalten - 1, zeilen - 1, this );
	spieler[1] = new Computer( 4, 6, this );
        initComponents();
        //setSize( 8*45, 8*45 );
    }
    
    private void initComponents() {
        
	FbMenue fbm = new FbMenue( this );
	setJMenuBar( fbm.getMenuBar() );
 
        JPanel board = new JPanel( new GridLayout(zeilen, spalten ));
        int count = 0;
	felder = new Feld[zeilen][spalten];
        for( int j=0; j<zeilen; j++ ) {
            for( int i=0; i<spalten; i++ ){
		Feld l = null; 
		if( Math.random() > 0.95 & istFrei( j, i )  ) {
		    l = new SperrFeld();
		    l.setWert( -10 );
		} else {
		    l = new Feld( "" );
		    l.setWert();
		    l.setText( "" + l.getWert() );
		    if( count % 2 == 0 ) {
			l.setBackground( Color.BLACK );
			l.setBlack();
		    } else {
			l.setBackground( Color.WHITE );
			l.setWhite();
		    }
		    l.addActionListener(this);
		    l.setActionCommand( ""+i+" "+j);
		    for( int is=0; is<spieler.length; is++ ) {
			if( i == spieler[is].getX() & j == spieler[is].getY() ) {
			    l.changeColor( );
			    l.setText( null );
			    l.setIcon( spieler[is].getIcon() );
			    l.setWert( -1 );
			    if( is == 0 ) current = l;
			}
		    }
		}
		++count;
		board.add( l );
		felder[j][i] = l;
            }
            ++count;
        }
	board.setPreferredSize( new Dimension( spalten * size, zeilen * size ) );

        getContentPane().setLayout( new FlowLayout() );
        getContentPane().add( board );

	JPanel comp = new JPanel(new GridLayout(0,1), false);
	scoreLabel = new JLabel[spieler.length];
	for( int is=0; is<spieler.length; is++ ) {
	    JLabel label = new JLabel( spieler[is].getName(), JLabel.CENTER);

	    scoreLabel[is] = new JLabel( "0000", JLabel.CENTER );
	    Border  raisedbevel, loweredbevel, twolevel;
	    raisedbevel  = BorderFactory.createRaisedBevelBorder();
	    loweredbevel = BorderFactory.createLoweredBevelBorder();
	    twolevel     =  BorderFactory.createCompoundBorder( raisedbevel, loweredbevel);
	    scoreLabel[is].setBorder( twolevel );
	    
	    comp.add( label );
	    comp.add( scoreLabel[is] );
	}
        //comp.setBorder( twolevel );

	getContentPane().add( comp );

        pack();
    }
    
    boolean istFrei( int i, int j ) {
	for( int is=0; is<spieler.length; is++ ) {
	    if( i == spieler[is].getY() & j == spieler[is].getX() ) {
		return false;
	    }
	}
	return true;
    }

    public int getWert( int i, int j ) {
	//System.out.println( i + " " + j);
	if( i < 0 | j < 0 | i >= zeilen | j >= spalten ) return -2;
	if( ! felder[i][j].isEnabled() ) return -3;
	if( ! istFrei( i, j ) )  return -4;
	return felder[i][j].getWert();
    }
    
    public void move( int i, int j, Computer c ) {
	felder[i][j].changeColor( );
	felder[i][j].setText( null );
	felder[i][j].setIcon( c.getIcon()  ); 
	felder[c.getY()][c.getX()].setEnabled( false );
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        // System.out.println( cmd );

	if( cmd.equals( "H_ber" ) ) {
	    JOptionPane.showMessageDialog(this, "FH-FB Springerspiel, Version " + version); 
	} else if( cmd.equals( "H_Hilfe" ) ) {
	    JOptionPane.showMessageDialog(this, "Noch keine Hilfe vorhanden" ); 
	} else if( cmd.equals( "G_Neu" ) ) {
	    //initComponents();
	    System.out.println( "Neues Spiel" );
	    new Brett().show();
	} else if( cmd.equals( "G_Exit" ) ) {
	    System.exit(0);
	} else { 
	    if( gameOver ) return;
	    StringTokenizer st = new StringTokenizer( cmd );
	    int x = Integer.parseInt(st.nextToken());
	    int y = Integer.parseInt(st.nextToken());
	    // System.out.println( x + "  " + y );
	    int xd = Math.abs( x - spieler[0].getX() );
	    int yd = Math.abs( y - spieler[0].getY() );
        
	    if( xd == 2 & yd == 1 | xd == 1 & yd == 2 ) {
		spieler[0].setX( x );
		spieler[0].setY( y );
		Feld b = (Feld) e.getSource();
		b.changeColor( );
		b.setText( null );
		b.setIcon( spieler[0].getIcon()  ); 
		scoreLabel[0].setText( "" + spieler[0].incScore( b.getWert() ) );
		current.setEnabled( false );
		current = b;
		((Computer) spieler[1]).move();
		scoreLabel[1].setText( "" + spieler[1].getScore( ) );
	    }
        }
    }
    
    public void computerGibtAuf() 
    {
	JOptionPane.showMessageDialog(this, "Computer gibt auf!\nBonus 20 Punkte" ); 
	scoreLabel[0].setText( "" + (spieler[0].getScore( )+20 ) );
	gameOver = true;
    }

    // *********************************************************
    public static void main(String[] args) {
        new Brett().show();
    }
}
